import discord
from cpl_core.logging.logger_abc import LoggerABC

from modules_core.abc.events.on_member_join_abc import OnMemberJoinABC
from modules_core.abc.events.on_message_abc import OnMessageABC
from modules_core.abc.events.on_voice_state_update_abc import OnVoiceStateUpdateABC
from modules_core.abc.module_abc import ModuleABC


class Base(ModuleABC, OnMemberJoinABC, OnMessageABC, OnVoiceStateUpdateABC):

    def __init__(self, logger: LoggerABC):

        self._logger = logger

        ModuleABC.__init__(self)
        self._priorities[OnMemberJoinABC] = 1
        self._priorities[OnMessageABC] = 30
        self._priorities[OnVoiceStateUpdateABC] = 10
        self._logger.trace(__name__, f'Module {type(self)} loaded')

    async def on_member_join(self, member: discord.Member):
        self._logger.debug(__name__, f'Module {type(self)} started')

    async def on_message(self, message: discord.Message):
        self._logger.debug(__name__, f'Module {type(self)} started')

    async def on_voice_state_update(self, member: discord.Member, before: discord.VoiceState, after: discord.VoiceState):
        self._logger.debug(__name__, f'Module {type(self)} started')
